﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Diagnostics;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            Thread thread = new Thread(ThreadFunc);
            thread.IsBackground = true;
            thread.Start();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            NewWindowTest();
        }

        int windowCount;

        private void NewWindowTest()
        {
            windowCount++;
            Form2 form = new Form2();
            form.Show();
            form.Shown += new EventHandler(form_Shown);
        }

        void form_Shown(object sender, EventArgs e)
        {
            ((sender) as Form).Close();

            if (windowCount >= 10000000)
            {
                return;
            }

            NewWindowTest();
        }

        void ThreadFunc(object state)
        {
            while (true)
            {
                Process currentProcess = Process.GetCurrentProcess();
                string txt = string.Format("{0,6}, {1,6}, {2,6}, {3,10}, {4,10}, {5,10}, {6,10}", GC.CollectionCount(0),
                    GC.CollectionCount(1), GC.CollectionCount(2), GC.GetTotalMemory(false),
                    currentProcess.WorkingSet64,
                    currentProcess.PrivateMemorySize64, windowCount);
                System.Diagnostics.Trace.WriteLine(txt);

                Thread.Sleep(1000 * 2);
            }
        }

    }
}
